#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#include <math.h>
#include <string.h>
#include "grb2.h"
#include "wgrib2.h"
#include "fnlist.h"

/*
 * the set options
 *
 * routines to modify grib fields
 *
 * 3/2008 Public Domain by Wesley Ebisuzaki
 *
 */

extern int header, decode, free_sec4;
extern const char *level_table[192];
int use_scale, dec_scale, bin_scale;

/*
 * HEADER:100:set_lev:misc:1:changes level code .. not complete
 */

int f_set_lev(ARG1) {
    unsigned char *p;
    const char *t;
    float val1, val2;
    double dval1;
    int pdt, i, n, n_percent, len_arg1, ival;
    char string[100];

    if (mode < 0) return 0;
    pdt = code_table_4_0(sec);
    len_arg1 = strlen(arg1);
    p = sec[4];

if (mode == 99) fprintf(stderr,"set_lev: pdt=%d arg=%s\n", pdt, arg1);

    if ( (pdt >= 0 && pdt <= 14) ) {
	for (i = 22; i <= 33; i++) p[i] = 255;

	for (i = 1; i < 192; i++) {
	    if (strcmp("reserved", level_table[i]) == 0) continue;

	    // count the number of % characters in the level table
            n_percent = 0;
	    t = level_table[i];
            while (*t) { if (*t++ == '%') n_percent++; }

	    if (n_percent == 0) {
	        if (strcmp(arg1, level_table[i]) == 0) {
 	            p[22] = i;
 	            return 0;
	        }
	    }

	    else if (n_percent == 1) {
		// add %n to the format given by level_table[i]
		strncpy(string,level_table[i], sizeof(string) );
		strncat(string,"%n", sizeof(string) );
		if (n = -1, sscanf(arg1,string,&val1,&n), n == len_arg1) {
		    dval1 = (double) val1;
		    p[22] = i;
		    if (i == 100 || i == 108) dval1 = dval1 * 100; // convert mb to Pa

		    best_scaled_value(dval1, &n, &ival);
		    p[23] = INT1(n);
		    int_char(ival, p+24);
		    return 0;
		}
	    }
//	    else if (n_percent == 2) {
//	    }
        }
if (mode == 99) fprintf(stderr,"in set_lev arg1=%s\n", arg1);
         
	if (n=-1, sscanf(arg1,"%g-%g mb above ground%n",&val1,&val2,&n), n == len_arg1) {
	    val1 *= 100.0;
	    val2 *= 100.0;
	    p[22] = p[28] = 108;
	    p[23] = 0;
	    int_char((int) val1, p+24);
	    p[29] = 0;
	    int_char((int) val2, p+30);
            return 0;
	}
	if (n=-1, sscanf(arg1,"%g-%g mb%n",&val1,&val2,&n), n == len_arg1) {
	    val1 *= 100.0;
	    val2 *= 100.0;
	    p[22] = p[28] = 108;
	    p[23] = 0;
	    int_char((int) val1, p+24);
	    p[29] = 0;
	    int_char((int) val2, p+30);
            return 0;
	}
	if (strcmp("atmos col", arg1) == 0 ||
	    strcmp("Entire atmosphere (considered as a single layer)",arg1) == 0) {
	    p[22] = 1;
	    p[28] = 8;
            return 0;
	}
        if (GB2_Center(sec) == 7 && (strcmp("high trop freezing lvl",arg1) == 0 ||
	        strcmp("Highest tropospheric freezing level",arg1) == 0)) {
	    p[22] = 204;
            return 0;
	}

    }
    fatal_error("need to modify set_lev for %s", arg1);
    return 0;
}


/*
 * HEADER:100:set_date:misc:1:changes date code .. not complete .. only analysis/fcst
 */

int f_set_date(ARG1) {

    char *p;
    int year, month, day, hour, minute, second, i, j, units;
    int pdt;

    unsigned int dtime;

    if (mode == -1) {
	return 0;
    }
    if (mode < 0) return 0;

        p = arg1;
        day = 1;
        second = minute = hour = 0;

        if (sscanf(p,"%4d",&year) == 0) fatal_error("set_date: year %s", arg1);
	p += 4;
        if (sscanf(p,"%2d",&month) == 0) fatal_error("set_date: month %s", arg1);
	p += 2;
        if (sscanf(p,"%2d",&day) == 1) {
	    p += 2;
            if (sscanf(p,"%2d",&hour) == 1) {
	        p += 2;
                if (sscanf(p,"%2d",&minute) == 1) {
	            p += 2;
                    sscanf(p,"%2d",&second);
		}
	    }
	}

    // set reference time
    save_time(year,month,day,hour,minute,second, sec[1]+12);

    pdt = i = code_table_4_0(sec);

    j = 0;
    if (i == 8) j = 34;
    else if (i == 9) j = 47;
    else if (i == 10) j = 35;
    else if (i == 11) j = 37;
    else if (i == 12) j = 36;
    else if (i == 13) j = 68;
    else if (i == 14) j = 64;

    if (j == 0) return 0;

    // add forecast time to time

    units = code_table_4_4(sec);
    dtime = forecast_time_in_units(sec);
    add_time(&year, &month, &day, &hour, &minute, &second, dtime, units);

    // add statistical processing time to time
    units = (int) sec[4][48+34-j];
    dtime = uint4(sec[4]+49+34-j);
    add_time(&year, &month, &day, &hour, &minute, &second, dtime, units);

    save_time(year,month,day,hour,minute,second, sec[4]+j);

    return 0;
}	

extern struct gribtab_s gribtab[];

/*
 * HEADER:100:set_var:misc:1:changes variable name
 */

int f_set_var(ARG1) {
    struct gribtab_s *p;
    if (mode == -1) {
	p = gribtab;
	while (p->disc != -1) {
	    if (strcmp(arg1,p->name) == 0) {
		*local = (void *) p;
		return 0;
	    }
	    p++;
	}
	fatal_error("set_var: could not find %s", arg1);
	*local = p;
    }
    else if (mode >= 0) {
	p = *local;
	sec[0][6] = p->disc;
        sec[1][9] = p->mtab;
        sec[1][10] = p->ltab;
        sec[4][9] = p->pcat;
        sec[4][10] = p->pnum;
    }
    return 0;
}

int set_var(ARG1) {
    struct gribtab_s *p;
    p = gribtab;
    while (p->disc != -1) {
        if (strcmp(arg1,p->name) == 0) {
            break;
        }
        p++;
    }
    if (p->disc == -1) fatal_error("set_var: could not find %s", arg1);
    sec[0][6] = p->disc;
    sec[1][9] = p->mtab;
    sec[1][10] = p->ltab;
    sec[4][9] = p->pcat;
    sec[4][10] = p->pnum;
    return 0;
}

/*
 * HEADER:100:set_center:misc:1:changes center X = C or C:S     C and S are center/subcenter numbers
 */

int f_set_center(ARG1) {
   int i, center, subcenter;

   if (mode >= 0) {
       i = sscanf(arg1,"%d:%d", &center, &subcenter);
       if (i == 0) fatal_error("set_center: bad arg %s", arg1);
       int2_char(center, sec[1]+5);
       if (i == 2) int2_char(subcenter, sec[1]+7);
    }
    return 0;
}

/*
 * HEADER:100:set:misc:2:set X = Y, X=local_table,etc (help: -set help help)
 */

static char *set_options="discipline, center, subcenter, master_table,"
	" local_table, table_1.2, table_1.3, table_1.4, table_3.0, table_3.1/GDT" 
	", table_3.3, table_3.4, table_4.0/PDT, table_4.1, table_4.2, table_4.6, table_5.0/DRT, table_6.0";


int f_set(ARG2) {
    int i;
    unsigned char *p;

    if (mode == -1) {
	if (strcmp(arg1,"help") == 0) {
	    sprintf(inv_out,"-set: change values of %s\n", set_options);
	    return -1;
	}
	return 0;
    }

    if (mode >= 0) {

	i = atoi(arg2);
	if (strcmp(arg1,"discipline") == 0) {
	    sec[1][10] = (unsigned char) i;
	    return 0;
	}
	if (strcmp(arg1,"local_table") == 0) {
	    sec[1][10] = (unsigned char) i;
	    return 0;
	}
	if (strcmp(arg1,"master_table") == 0) {
	    sec[1][9] = (unsigned char) i;
	    return 0;
	}
	if (strcmp(arg1,"center") == 0) {
            int2_char(i, sec[1]+5);
	    return 0;
	}
	if (strcmp(arg1,"subcenter") == 0) {
            int2_char(i, sec[1]+7);
	    return 0;
	}
	if (strcmp(arg1,"table_1.2") == 0) {
	    sec[1][11] = (unsigned char) i;
	    return 0;
	}
	if (strcmp(arg1,"table_1.3") == 0) {
	    sec[1][19] = (unsigned char) i;
	    return 0;
	}
	if (strcmp(arg1,"table_1.4") == 0) {
	    sec[1][20] = (unsigned char) i;
	    return 0;
	}
	if (strcmp(arg1,"table_3.0") == 0) {
	    sec[3][5] = (unsigned char) i;
	    return 0;
	}
	if (strcmp(arg1,"table_3.1") == 0 || strcmp(arg1,"GDT") == 0) {
            uint2_char(i, sec[3]+12);
	    return 0;
	}
	if (strcmp(arg1,"table_3.3") == 0 || strcmp(arg1,"flag_table_3.3") == 0) {
	    return set_flag_table_3_3(sec, i);
	}
	if (strcmp(arg1,"table_3.4") == 0 || strcmp(arg1,"flag_table_3.4") == 0) {
	    return set_flag_table_3_4(sec, i);
	}
	if (strcmp(arg1,"table_4.0") == 0 || strcmp(arg1,"PDT") == 0) {
            uint2_char(i, sec[4]+7);
	    return 0;
	}
	if (strcmp(arg1,"table_4.1") == 0) {
	    sec[4][9] = (unsigned char) i;
	    return 0;
	}
	if (strcmp(arg1,"table_4.2") == 0) {
	    sec[4][10] = (unsigned char) i;
	    return 0;
	}
	if (strcmp(arg1,"table_4.6") == 0) {
	    p = code_table_4_6_location(sec);
	    *p = (unsigned char) i;
	    return 0;
	}
	if (strcmp(arg1,"table_5.0") == 0 || strcmp(arg1,"DRT") == 0) {
            uint2_char(i, sec[5]+9);
	    return 0;
	}
	if (strcmp(arg1,"table_6.0") == 0) {
	    sec[6][5] = (unsigned char) i;
	    return 0;
	}
	fatal_error("set: allowed values: %s", set_options);

	return 1;
    }
    return 0;
}

/*
 * HEADER:100:set_ftime:misc:1:set ftime .. only on pdt=4.0 only anl/fcst
 */

int f_set_ftime(ARG1) {
    int pdt, n, unit;
    char string[STRING_SIZE];

    if (mode < 0) return 0;

    pdt = GB2_ProdDefTemplateNo(sec);
    n = 0;
    unit = -1;
    if (strcmp(arg1 ,"anl") == 0) {
	n = 0;
	unit = 1;
    }
    else {
        if (sscanf(arg1,"%d %s", &n , string) == 2) {
	    if (strcmp(string,"minute") == 0) unit = 0;
	    else if (strcmp(string,"hour") == 0) unit = 1;
	    else if (strcmp(string,"day") == 0) unit = 2;
	    else if (strcmp(string,"month") == 0) unit = 3;
	    else if (strcmp(string,"year") == 0) unit = 4;
	}
    }
    if (unit == -1) fatal_error("set_ftime: %s not understood", arg1);
    if (pdt == 0) {
        sec[4][17] = (unsigned char) unit;
        int_char(n,sec[4]+18);
        return 0;
    }
    return -1;
}

/*
 * HEADER:100:set_ave:misc:1:set ftime .. only on pdt=4.0 only anl/fcst
 */

/* not finished */

int f_set_ave(ARG1) {
    int i , pdt,tr;
    char string[STRING_SIZE];
    char string2[STRING_SIZE];
    char string3[STRING_SIZE];
    static unsigned char new_sec4[58];

    int year, month, day, hour, minute, second;
    int j,k;

    if (mode < 0) return 0;

    pdt = GB2_ProdDefTemplateNo(sec);


//  6 hour ave anl

    i = sscanf(arg1,"%d %s %s %s",&j,string,string2,string3);
    if (i == 4 && 
	((tr = a2time_range(string)) >= 0) &&
	(strcmp(string2,"acc") == 0 || strcmp(string2,"ave") == 0 ||
		strcmp(string2,"max") == 0 || strcmp(string2,"min") == 0) &&
        (strcmp(string3,"anl") == 0) ) {

	for (i = 0; i < 34; i++) new_sec4[i] = sec[4][i];
	get_time(sec[1]+12, &year, &month, &day, &hour, &minute, &second);
        add_time(&year, &month, &day, &hour, &minute, &second, j, 1);
        save_time(year, month, day, hour, minute, second, new_sec4+34);

        uint_char(58, new_sec4);
        uint2_char(8, new_sec4+7);              // pdt = 8
        new_sec4[17] = tr;		    	// hour, etc
        uint_char(0, new_sec4+18);              // start time
        new_sec4[41] = 1;                       // number of time ranges
        uint_char(0, new_sec4+42);              // missing

        if (strcmp(string2,"ave") == 0) new_sec4[46] = 0;
        if (strcmp(string2,"acc") == 0) new_sec4[46] = 1;
        if (strcmp(string2,"max") == 0) new_sec4[46] = 2;
        if (strcmp(string2,"min") == 0) new_sec4[46] = 3;

        new_sec4[47] = 1;

        new_sec4[48] = tr;                       // hour
        uint_char(j, new_sec4+49);
        new_sec4[53] = tr;
        uint_char(0, new_sec4+54);
        sec[4] = &(new_sec4[0]);
        return 0;
    }
    i = sscanf(arg1,"%d-%d %s %s %s",&j,&k,string3,string,string2);
    if (i == 5 && 
	(tr = a2time_range(string3)) >= 00 &&
	(strcmp(string,"acc") == 0 || strcmp(string,"ave") == 0 ||
		strcmp(string,"max") == 0 || strcmp(string,"min") == 0) &&
		(strcmp(string2,"anl") == 0 || strcmp(string2,"fcst") == 0) ) {

	for (i = 0; i < 34; i++) new_sec4[i] = sec[4][i];

	get_time(sec[1]+12, &year, &month, &day, &hour, &minute, &second);
        add_time(&year, &month, &day, &hour, &minute, &second, k, 1);
        save_time(year, month, day, hour, minute, second, new_sec4+34);

        uint_char(58, new_sec4);
        uint2_char(8, new_sec4+7);              // pdt = 8
        new_sec4[17] = tr;			// hour
        uint_char(j, new_sec4+18);		// start time
        new_sec4[41] = 1;			// number of time ranges
        uint_char(0, new_sec4+42);		// missing

        if (strcmp(string,"ave") == 0) new_sec4[46] = 0;
        if (strcmp(string,"acc") == 0) new_sec4[46] = 1;
        if (strcmp(string,"max") == 0) new_sec4[46] = 2;
        if (strcmp(string,"min") == 0) new_sec4[46] = 3;

        if (strcmp(string2,"anl") == 0) new_sec4[47] = 1;
        if (strcmp(string2,"fcst") == 0) new_sec4[47] = 2;

        new_sec4[48] = tr;			// hour
	uint_char(k-j, new_sec4+49);
        new_sec4[53] = tr;
        uint_char(0, new_sec4+54);
	sec[4] = &(new_sec4[0]);
        return 0;
    }
    fatal_error("set_ave: not implemented %s", arg1);
    return 0;
}

/*
 * HEADER:100:set_metadata:misc:1:read meta-data for grib writing from file X
 */

int f_set_metadata(ARG1) {
    char line[STRING_SIZE];
    char date[STRING_SIZE];
    char var[STRING_SIZE];
    char lev[STRING_SIZE];
    char ftime[STRING_SIZE];
    int i;

    if (mode == -1) {
        if ((*local = (void *) ffopen(arg1,"r")) == NULL) {
            fatal_error("Could not open %s", arg1);
        }
    }
    else if (mode >= 0) {
	if (fgets(line, STRING_SIZE, (FILE *)*local) == NULL) {
	    return 1;
	}
        i = sscanf(line, "%*[^:]:%*[^:]:d=%[^:]:%[^:]:%[^:]:%[^:]", 
		date, var, lev, ftime);
	if (i != 4) fatal_error("set_metadata: bad input %s",line);

	arg1 = date;
	if (f_set_date(CALL_ARG1) != 0) return 1;

	arg1 = var;
	if (set_var(CALL_ARG1) != 0) return 1;

	arg1 = lev;
	if (f_set_lev(CALL_ARG1) != 0) return 1;

	arg1 = ftime;
	if (f_set_ftime(CALL_ARG1) != 0) return 1;
	
    }
    return 0;
}

/*
 * HEADER:100:set_flag_table_3.3:misc:1:flag table 3.3 = X
 */

int f_set_flag_table_3_3(ARG1) {
    if (mode >= 0) return set_flag_table_3_3(sec, atoi(arg1));
    return 0;
}

/*
 * HEADER:100:set_flag_table_3.4:misc:1:flag table 3.4 = X
 */

int f_set_flag_table_3_4(ARG1) {
    if (mode >= 0) return set_flag_table_3_4(sec, atoi(arg1));
    return 0;
}
